<%@ page language="java" %>
<%@ page errorPage="/common/Error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://www.springframework.org/tags/form" prefix="form" %>
<%@ taglib uri="http://tiles.apache.org/tags-tiles" prefix="tiles" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<c:url var="AddUsersUrl" value="/admin/role/AddUsers.do"/>
<form:form method="POST" action="${AddUsersUrl}" modelAttribute="AddUsersForm">
<input type="hidden" name="EV_CSRF_NONCE_Token" value="${EV_CSRF_NONCE_Token}" />
<tiles:insertDefinition name=".page.title.admin.role">
  <tiles:putAttribute name="titleKey" value="admin.role.add.users"/>
  <tiles:putAttribute name="titleName" value="${Role.name}"/>
</tiles:insertDefinition>

<tiles:insertDefinition name=".portlet.error"/>

<tiles:insertTemplate template="/admin/role/RoleUsersForm.jsp">
  <tiles:putAttribute name="availableUsers" value="${AvailableUsers}"/>
  <tiles:putAttribute name="numAvailableUsers" value="${AvailableUsers_totalSize}"/>
  <tiles:putAttribute name="pendingUsers" value="${PendingUsers}"/>
  <tiles:putAttribute name="numPendingUsers" value="${PendingUsers_totalSize}"/>
</tiles:insertTemplate>

<tiles:insertDefinition name=".form.buttons">
  <tiles:putAttribute name="addToList" value="true"/>
</tiles:insertDefinition>

<tiles:insertDefinition name=".page.footer"/>
<input type="hidden" name="r" value="${Role.id}"/>
</form:form>
