<%@ page language="java" %>
<%@ page errorPage="/common/Error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://tiles.apache.org/tags-tiles" prefix="tiles" %>
<%@ taglib uri="http://www.springframework.org/tags/form" prefix="form" %>

<c:url var="editRoleUrl" value="/admin/role/Edit.do"/>
<form:form action="${editRoleUrl}" method="POST" modelAttribute="roleForm">
<input type="hidden" name="EV_CSRF_NONCE_Token" value="${EV_CSRF_NONCE_Token}" />
	<tiles:insertDefinition name=".page.title.admin.role">
	  	<tiles:putAttribute name="titleName" value="${Role.name}" />
	</tiles:insertDefinition>
	<tiles:insertDefinition name=".portlet.error" />
	
	<tiles:insertTemplate template="/admin/role/RolePropertiesForm.jsp">
	  <tiles:putAttribute name="role" value="${Role}"/>
	  <tiles:putAttribute name="mode" value="edit"/>
	</tiles:insertTemplate>
	<tiles:insertTemplate template="/admin/role/RolePermissionsForm.jsp" />
	<tiles:insertDefinition name=".form.buttons"/>
	<tiles:insertDefinition name=".page.footer"/>
	<form:hidden path="r"/>
</form:form>
