<%@ page language="java"%>
<%@ page errorPage="/common/Error.jsp"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@ taglib uri="http://tiles.apache.org/tags-tiles" prefix="tiles" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://www.springframework.org/tags/form" prefix="form" %>
<c:url var="newRoleUrl" value="/admin/role/New.do"/>
 
<form:form action="${newRoleUrl}" method="POST" modelAttribute="roleForm" >
<input type="hidden" name="EV_CSRF_NONCE_Token" value="${EV_CSRF_NONCE_Token}" />    
 
	<tiles:insertDefinition name=".page.title.admin.role">
		<tiles:putAttribute name="titleKey" value="admin.role.NewRolePageTitle" />
	</tiles:insertDefinition>
	<tiles:insertDefinition name=".portlet.error" />

	<tiles:insertTemplate template="/admin/role/RolePropertiesForm.jsp" />
	<tiles:insertDefinition name=".toolbar.empty" />
	<img src="/images/spacer.gif" width="1" height="15" border="0" />
	<tiles:insertTemplate template="/admin/role/RolePermissionsForm.jsp" />
	<tiles:insertDefinition name=".form.buttons" />
	<tiles:insertDefinition name=".page.footer">
		<tiles:putAttribute name="msgKey" value="admin.role.new.AssignUsersEtc" />
	</tiles:insertDefinition>  
 
 
</form:form>