<%@ page language="java" %>
<%@ page errorPage="/common/Error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>

<%@ taglib uri="http://tiles.apache.org/tags-tiles" prefix="tiles" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="/WEB-INF/tld/hq.tld" prefix="hq" %>
<%@ taglib uri="/WEB-INF/tld/display.tld" prefix="display" %>
<%@ taglib tagdir="/WEB-INF/tags/jsUtils" prefix="jsu" %>
<%@ taglib uri="http://www.springframework.org/tags/form" prefix="form" %>
<%@ taglib uri="https://www.owasp.org/index.php/OWASP_Java_Encoder_Project" prefix="owasp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>

<jsu:importScript path="/js/listWidget.js" />
<c:set var="userWidgetInstanceName" value="assignedUsers"/>
<c:set var="groupWidgetInstanceName" value="assignedGroups"/>
<jsu:script>
	var pageData = new Array();

	initializeWidgetProperties('<c:out value="${userWidgetInstanceName}"/>');
	userWidgetProperties = getWidgetProperties('<c:out value="${userWidgetInstanceName}"/>');
	initializeWidgetProperties('<c:out value="${groupWidgetInstanceName}"/>');
	groupWidgetProperties = getWidgetProperties('<c:out value="${groupWidgetInstanceName}"/>');
</jsu:script>
<c:url var="selfPnuAction" value="/admin/role/RoleAdmin.do">
  	<c:param name="mode" value="view"/>
  	<c:param name="r" value="${Role.id}"/>
  	<c:if test="${not empty param.psu}">
    	<c:param name="psu" value="${owasp:forUriComponent(param.psu)}"/>
  	</c:if>
  	<c:if test="${not empty param.sou}">
    	<c:param name="sou" value="${owasp:forUriComponent(param.sou)}"/>
  	</c:if>
  	<c:if test="${not empty param.scu}">
    	<c:param name="scu" value="${owasp:forUriComponent(param.scu)}"/>
  	</c:if>
  	<c:if test="${not empty param.psg}">
    	<c:param name="psg" value="${owasp:forUriComponent(param.psg)}"/>
  	</c:if>
  	<c:if test="${not empty param.png}">
    	<c:param name="png" value="${owasp:forUriComponent(param.png)}"/>
  	</c:if>
  	<c:if test="${not empty param.sog}">
    	<c:param name="sog" value="${owasp:forUriComponent(param.sog)}"/>
  	</c:if>
  	<c:if test="${not empty param.scg}">
    	<c:param name="scg" value="${owasp:forUriComponent(param.scg)}"/>
  	</c:if>
</c:url>
<c:url var="selfPngAction" value="/admin/role/RoleAdmin.do">
  	<c:param name="mode" value="view"/>
  	<c:param name="r" value="${Role.id}"/>
  	<c:if test="${not empty param.psu}">
    	<c:param name="psu" value="${owasp:forUriComponent(param.psu)}"/>
  	</c:if>
  	<c:if test="${not empty param.pnu}">
    	<c:param name="pnu" value="${owasp:forUriComponent(param.pnu)}"/>
  	</c:if>
  	<c:if test="${not empty param.sou}">
    	<c:param name="sou" value="${owasp:forUriComponent(param.sou)}"/>
  	</c:if>
  	<c:if test="${not empty param.scu}">
    	<c:param name="scu" value="${owasp:forUriComponent(param.scu)}"/>
  	</c:if>
  	<c:if test="${not empty param.psg}">
    	<c:param name="psg" value="${owasp:forUriComponent(param.psg)}"/>
  	</c:if>
  	<c:if test="${not empty param.sog}">
    	<c:param name="sog" value="${owasp:forUriComponent(param.sog)}"/>
  	</c:if>
  	<c:if test="${not empty param.scg}">
    	<c:param name="scg" value="${owasp:forUriComponent(param.scg)}"/>
  	</c:if>
</c:url>
<c:url var="selfPsuAction" value="/admin/role/RoleAdmin.do">
  	<c:param name="mode" value="view"/>
  	<c:param name="r" value="${Role.id}"/>
  	<c:if test="${not empty param.pnu}">
    	<c:param name="pnu" value="${owasp:forUriComponent(param.pnu)}"/>
  	</c:if>
  	<c:if test="${not empty param.sou}">
    	<c:param name="sou" value="${owasp:forUriComponent(param.sou)}"/>
  	</c:if>
  	<c:if test="${not empty param.scu}">
    	<c:param name="scu" value="${owasp:forUriComponent(param.scu)}"/>
  	</c:if>
  	<c:if test="${not empty param.png}">
    	<c:param name="png" value="${owasp:forUriComponent(param.png)}"/>
  	</c:if>
  	<c:if test="${not empty param.psg}">
    	<c:param name="psg" value="${owasp:forUriComponent(param.psg)}"/>
  	</c:if>
  	<c:if test="${not empty param.sog}">
    	<c:param name="sog" value="${owasp:forUriComponent(param.sog)}"/>
  	</c:if>
  	<c:if test="${not empty param.scg}">
    	<c:param name="scg" value="${owasp:forUriComponent(param.scg)}"/>
  	</c:if>
</c:url>
<c:url var="selfPsgAction" value="/admin/role/RoleAdmin.do">
  	<c:param name="mode" value="view"/>
  	<c:param name="r" value="${Role.id}"/>
  	<c:if test="${not empty param.pnu}">
    	<c:param name="pnu" value="${owasp:forUriComponent(param.pnu)}"/>
  	</c:if>
  	<c:if test="${not empty param.psu}">
    	<c:param name="psu" value="${owasp:forUriComponent(param.psu)}"/>
  	</c:if>
  	<c:if test="${not empty param.sou}">
    	<c:param name="sou" value="${owasp:forUriComponent(param.sou)}"/>
  	</c:if>
  	<c:if test="${not empty param.scu}">
    	<c:param name="scu" value="${owasp:forUriComponent(param.scu)}"/>
  	</c:if>
  	<c:if test="${not empty param.png}">
    	<c:param name="png" value="${owasp:forUriComponent(param.png)}"/>
  	</c:if>
  	<c:if test="${not empty param.sog}">
    	<c:param name="sog" value="${owasp:forUriComponent(param.sog)}"/>
  	</c:if>
  	<c:if test="${not empty param.scg}">
    	<c:param name="scg" value="${owasp:forUriComponent(param.scg)}"/>
  	</c:if>
</c:url>
<c:url var="selfPuAction" value="/admin/role/RoleAdmin.do">
  	<c:param name="mode" value="view"/>
  	<c:param name="r" value="${Role.id}"/>
  	<c:if test="${not empty param.pnu}">
    	<c:param name="pnu" value="${owasp:forUriComponent(param.pnu)}"/>
  	</c:if>
  	<c:if test="${not empty param.psu}">
    	<c:param name="psu" value="${owasp:forUriComponent(param.psu)}"/>
  	</c:if>
  	<c:if test="${not empty param.png}">
    	<c:param name="png" value="${owasp:forUriComponent(param.png)}"/>
  	</c:if>
  	<c:if test="${not empty param.psg}">
    	<c:param name="psg" value="${owasp:forUriComponent(param.psg)}"/>
  	</c:if>
  	<c:if test="${not empty param.sog}">
    	<c:param name="sog" value="${owasp:forUriComponent(param.sog)}"/>
  	</c:if>
  	<c:if test="${not empty param.scg}">
    	<c:param name="scg" value="${owasp:forUriComponent(param.scg)}"/>
  	</c:if>
</c:url>
<c:url var="selfPgAction" value="/admin/role/RoleAdmin.do">
  	<c:param name="mode" value="view"/>
  	<c:param name="r" value="${Role.id}"/>
  	<c:if test="${not empty param.pnu}">
    	<c:param name="pnu" value="${owasp:forUriComponent(param.pnu)}"/>
  	</c:if>
  	<c:if test="${not empty param.psu}">
    	<c:param name="psu" value="${owasp:forUriComponent(param.psu)}"/>
  	</c:if>
  	<c:if test="${not empty param.sou}">
	    <c:param name="sou" value="${owasp:forUriComponent(param.sou)}"/>
  	</c:if>
  	<c:if test="${not empty param.scu}">
    	<c:param name="scu" value="${owasp:forUriComponent(param.scu)}"/>
  	</c:if>
  	<c:if test="${not empty param.png}">
    	<c:param name="png" value="${owasp:forUriComponent(param.png)}"/>
  	</c:if>
  	<c:if test="${not empty param.psg}">
    	<c:param name="psg" value="${owasp:forUriComponent(param.psg)}"/>
  	</c:if>
</c:url>
<tiles:insertDefinition name=".page.title.admin.role">
	<tiles:putAttribute name="titleName" value="${Role.name}" />
</tiles:insertDefinition>
<c:url var="listRoleUrl" value="/admin/role/RoleAdmin.do">
	<c:param name="mode" value="list"/>
</c:url>
<tiles:insertDefinition name=".page.return">
  	<tiles:putAttribute name="returnUrl" value="${listRoleUrl}"/>
  	<tiles:putAttribute name="returnKey" value="admin.role.view.ReturnToRoles"/>
</tiles:insertDefinition>

<tiles:insertDefinition name=".portlet.confirm"/>
<tiles:insertDefinition name=".portlet.error.calendar"/>

<tiles:insertTemplate template="/admin/role/RolePropertiesForm.jsp">
  	<tiles:putAttribute name="mode" value="view"/>
  	<tiles:putAttribute name="role" value="${Role}"/>
</tiles:insertTemplate>
 
<c:url var="viewRole" value="/admin/role/View.do"/>
<form:form action="${viewRole}" modelAttribute="roleForm">
	<tiles:insertTemplate template="/admin/role/RolePermissionsForm.jsp">
  		<tiles:putAttribute name="mode" value="view"/>
	</tiles:insertTemplate>
</form:form>
<c:if test="${Role.id != 0 && useroperations['modifyRole']}">
	<c:url var="editRoleUrl" value="/admin/role/RoleAdmin.do">
		<c:param name="mode" value="edit"/>
	</c:url>
	<tiles:insertDefinition name=".toolbar.edit">
  		<tiles:putAttribute name="editUrl" value="${editRoleUrl}"/>
  		<tiles:putAttribute name="editParamName" value="r"/>
  		<tiles:putAttribute name="editParamValue" value="${Role.id}"/>
	</tiles:insertDefinition>
</c:if>
<br/>
<c:url var="removeUsers" value="/admin/role/RemoveUsers.do"/>
<form:form method="POST" action="${removeUsers}" modelAttribute="RemoveUsersForm">
<input type="hidden" name="EV_CSRF_NONCE_Token" value="${EV_CSRF_NONCE_Token}" />
	<tiles:insertDefinition name=".header.tab">
  		<tiles:putAttribute name="tabKey" value="admin.role.users.AssignedUsersTab"/>
	</tiles:insertDefinition>
	<display:table items="${RoleUsers}" var="user" action="${selfPuAction}" orderValue="sou" order="${owasp:forUriComponent(param.sou)}" sortValue="scu" sort="${owasp:forUriComponent(param.scu)}" pageValue="pnu" page="${owasp:forUriComponent(param.pnu)}" pageSizeValue="psu" pageSize="${owasp:forUriComponent(param.psu)}" width="100%" cellpadding="0" cellspacing="0">
  		<display:column width="1%" property="id" title="<input type=\"checkbox\" onclick=\"ToggleAll(this, userWidgetProperties, true)\" name=\"listToggleAll\">" isLocalizedTitle="false" styleClass="ListCellCheckbox" headerStyleClass="ListHeaderCheckbox" >
    		<display:checkboxdecorator name="u" onclick="ToggleSelection(this, userWidgetProperties, true)" styleClass="listMember" suppress="1"/>
  		</display:column>
  		<display:column href="/admin/user/UserAdmin.do?mode=view" paramId="u" paramProperty="id" width="25%" value="${user.name}" title="admin.role.users.UsernameTH" sort="true" sortAttr="3" defaultSort="true"/>
  		<display:column width="75%" property="firstName" title="admin.role.users.FirstNameTH"/> <!-- XXX: add new sortAttr for firstName -->
	</display:table>
	<c:url var="addToListUrl" value="/admin/role/RoleAdmin.do">
		<c:param name="mode" value="addUsers"/>
	</c:url>
	<tiles:insertDefinition name=".toolbar.addToList">
  		<tiles:putAttribute name="showAddToListBtn"><c:out value="${(Role.id == 0 && isSubjectInRole && useroperations['modifyRole'] && useroperations['viewSubject']) || (Role.id != 0 && useroperations['modifyRole'] && useroperations['viewSubject'])}"/></tiles:putAttribute>
  		<tiles:putAttribute name="showRemoveBtn"><c:out value="${(Role.id == 0 && isSubjectInRole && useroperations['modifyRole'] !=null) || (Role.id != 0 && useroperations['modifyRole'] != null)}"/></tiles:putAttribute>
  		<tiles:putAttribute name="addToListUrl" value="${addToListUrl}"/>
		<tiles:putAttribute name="widgetInstanceName" value="${userWidgetInstanceName}"/>
  		<tiles:putAttribute name="addToListParamName" value="r"/>
  		<tiles:putAttribute name="addToListParamValue" value="${Role.id}"/>
  		<tiles:putAttribute name="listItems" value="${RoleUsers}"/>
  		<tiles:putAttribute name="listSize" value="${totalSize}"/>
  		<tiles:putAttribute name="pageSizeParam" value="psu"/>
  		<tiles:putAttribute name="pageSizeAction" value="${selfPsuAction}"/>
  		<tiles:putAttribute name="pageNumParam" value="pnu"/>
  		<tiles:putAttribute name="pageNumAction" value="${selfPnuAction}"/>
	</tiles:insertDefinition>
	<input type="hidden" name="r" value="${Role.id}"/>
	
</form:form>
<br/>
<c:if test="${not Role.system}">
	<c:url var="removeResourceGroups" value="/admin/role/RemoveResourceGroups.do"/>
	<form:form method="POST" action="${removeResourceGroups}" modelAttribute="RemoveResourceGroupsForm">
        <input type="hidden" name="EV_CSRF_NONCE_Token" value="${EV_CSRF_NONCE_Token}" />	
		<tiles:insertDefinition name=".header.tab">
  			<tiles:putAttribute name="tabKey" value="admin.role.groups.AssignedGroupsTab"/>
		</tiles:insertDefinition>
		<hq:constant classname="org.hyperic.hq.appdef.shared.AppdefEntityConstants" 
    				 symbol="APPDEF_TYPE_GROUP" var="CONST_GROUP_TYPE" />
		<display:table items="${RoleResGrps}" var="group" action="${selfPgAction}" orderValue="sog" order="{owasp:forUriComponent(param.sog)}" sortValue="scg" sort="${owasp:forUriComponent(param.scg)}" pageValue="png" page="${owasp:forUriComponent(param.png)}" pageSizeValue="psg" pageSize="${owasp:forUriComponent(param.psg)}" width="100%" cellpadding="0" cellspacing="0">
  			<display:column width="1%" property="id" title="<input type=\"checkbox\" onclick=\"ToggleAll(this, groupWidgetProperties, true)\" name=\"listToggleAll\">" isLocalizedTitle="false" styleClass="ListCellCheckbox" headerStyleClass="ListHeaderCheckbox" >
    			<display:checkboxdecorator name="g" onclick="ToggleSelection(this, groupWidgetProperties, true)" styleClass="listMember"/>
  			</display:column>
  			<display:column width="25%" property="name" href="/Resource.do?rid=${fn:escapeXml(group.id)}&type=${CONST_GROUP_TYPE}" title="common.header.Group" sort="true" sortAttr="2" defaultSort="true"/>
  			<display:column width="75%" property="description" title="common.header.Description"/>
		</display:table>
		<c:url var="addGroupsRoleUrl" value="/admin/role/RoleAdmin.do">
			<c:param name="mode" value="addGroups"/>
		</c:url>
		<tiles:insertDefinition name=".toolbar.addToList">
  			<tiles:putAttribute name="showAddToListBtn"><c:out value="${useroperations['modifyRole'] && useroperations['viewResourceGroup']}"/></tiles:putAttribute>
  			<tiles:putAttribute name="showRemoveBtn"><c:out value="${useroperations['modifyRole'] != null}"/></tiles:putAttribute>
  			<tiles:putAttribute name="addToListUrl" value="${addGroupsRoleUrl}"/>
  			<tiles:putAttribute name="widgetInstanceName" value="${groupWidgetInstanceName}"/>
  			<tiles:putAttribute name="addToListParamName" value="r"/>
  			<tiles:putAttribute name="addToListParamValue" value="${Role.id}"/>
  			<tiles:putAttribute name="listItems" value="${RoleResGrps}"/>
  			<tiles:putAttribute name="listSize" value="${NumResGrps}"/>
  			<tiles:putAttribute name="pageSizeParam" value="psg"/>
  			<tiles:putAttribute name="pageSizeAction" value="${selfPsgAction}"/>
  			<tiles:putAttribute name="pageNumParam" value="png"/>
  			<tiles:putAttribute name="pageNumAction" value="${selfPngAction}"/>  
		</tiles:insertDefinition>
		<input type="hidden" name="r" value="${Role.id}"/>
	</form:form>
	<br/>
</c:if>

<tiles:insertTemplate template="RoleCalendar.jsp"/>
<tiles:insertDefinition name=".page.return">
  	<tiles:putAttribute name="returnUrl" value="${listRoleUrl}"/>
  	<tiles:putAttribute name="returnKey" value="admin.role.view.ReturnToRoles"/>
</tiles:insertDefinition>
<tiles:insertDefinition name=".page.footer"/>