<%@ page language="java" %>
<%@ page errorPage="/common/Error.jsp" %>
<%@ taglib uri="http://www.springframework.org/tags/form" prefix="form2" %>
<%@ taglib uri="http://tiles.apache.org/tags-tiles" prefix="tiles" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<%--
  NOTE: This copyright does *not* cover user programs that use HQ
  program services by normal system calls through the application
  program interfaces provided as part of the Hyperic Plug-in Development
  Kit or the Hyperic Client Development Kit - this is merely considered
  normal use of the program, and does *not* fall under the heading of
  "derived work".
  
  Copyright (C) [2004, 2005, 2006], Hyperic, Inc.
  This file is part of HQ.
  
  HQ is free software; you can redistribute it and/or modify
  it under the terms version 2 of the GNU General Public License as
  published by the Free Software Foundation. This program is distributed
  in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
  even the implied warranty of MERCHANTABILITY or FITNESS FOR A
  PARTICULAR PURPOSE. See the GNU General Public License for more
  details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA.
 --%>

<c:url var="newDefUrl" value="/alerts/New.do"/>
<form2:form action="${newDefUrl}"  method="POST" enctype="multipart/form-data" modelAttribute="definitionNewForm">
<tiles:insertDefinition name=".page.title.events">
	<tiles:putAttribute name="titleKey" value="alert.config.edit.NewAlertDef.PageTitle"/>
</tiles:insertDefinition>
<tiles:insertDefinition name=".portlet.error"/>

<c:choose>
<c:when test="${not empty ResourceType}">
<form2:hidden path="aetid"/>
</c:when>
<c:otherwise>
<form2:hidden path="eid" value="${Resource.entityId}"/>
</c:otherwise>
</c:choose>
 
<tiles:insertDefinition name=".events.config.new.properties"/>

<tiles:insertDefinition name=".events.config.conditions">
  <tiles:putAttribute name="formName" value="definitionNewForm"/>
</tiles:insertDefinition>

<tiles:insertDefinition name=".events.config.form.buttons"/>

<tiles:insertDefinition name=".page.footer"/>
<input type="hidden" name="EV_CSRF_NONCE_Token" value="${EV_CSRF_NONCE_Token}" />
</form2:form>
