<%@ page language="java" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://www.springframework.org/tags/form" prefix="form" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ include file="/common/replaceButton.jsp"%>

<c:url var="setOpennms" value="/alerts/SetOpenNMSAction.do"/>
<form:form method="POST" action="${setOpennms}" modelAttribute="openNMSForm" >
	<table width="100%" cellpadding="0" cellspacing="0" border="0" class="TableBottomLine">
  		<tr>
    		<td colspan="4" align="left" class="ErrorField"><form:errors path="*" /></td>
  		</tr>
  		<tr>
    		<td class="BlockLabel"><fmt:message key="alert.config.edit.opennms.server"/></td>
    		<td class="BlockContent">
			<c:if test="${openNMSForm.canModify}">
	    		<form:input path="server"/>
	    	</c:if>
			<c:if test="${not openNMSForm.canModify}">	 
	    		<form:input path="server" disabled="true" />
	    	</c:if>
    		</td>
    		<td class="BlockLabel"><fmt:message key="alert.config.edit.opennms.port"/></td>
    		<td class="BlockContent">
    			<c:if test="${openNMSForm.canModify}">
	    			<form:input path="port"/>
	    		</c:if>
			    <c:if test="${not openNMSForm.canModify}">	 
	    			<form:input path="port" disabled="true"/>
	    		</c:if>
    		</td>
  		</tr>
	</table>
	<form:hidden path="ad"/>
	<form:hidden path="id"/>
	<form:hidden path="aetid"/>
	<form:hidden path="eid"/>
	<input type="hidden" name="EV_CSRF_NONCE_Token" value="${EV_CSRF_NONCE_Token}" />
	
	<c:if test="${openNMSForm.canModify}">
		<table width="100%" cellpadding="5" cellspacing="0" border="0" class="ToolbarContent">
  			<tr>
  				<td align="center">
  					<input type="image" src="/images/tbb_set.gif" border="0" alt="<fmt:message key='FormButtons.ClickToOk'/>" name="ok" style="padding-right: 5px;"/>
    				<input type="image"  src="/images/tbb_remove.gif" border="0" alt="<fmt:message key='FormButtons.ClickToDelete'/>" name="delete" style="padding-left: 5px;"/>
    			</td>
    		</tr>
		</table>
	</c:if>
</form:form>
