<%@ page language="java" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://www.springframework.org/tags/form" prefix="form" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ include file="/common/replaceButton.jsp"%>

<c:url var="setScript" value="/alerts/SetScriptAction.do"/>
<form:form method="POST" action="${setScript}" modelAttribute="scriptActionForm" >
	<table width="100%" cellpadding="0" cellspacing="0" border="0" class="TableBottomLine">
		<tr>
			<td colspan="4" align="left" class="ErrorField"><form:errors path="*" /></td>
		</tr>
  		<tr>
    		<td class="BlockLabel"><fmt:message key="alert.config.edit.script.path"/></td>
    		<td class="BlockContent">
			<c:if test="${scriptActionForm.canModify}">
				<form:input path="script" size="100" />
			</c:if>
			<c:if test="${not scriptActionForm.canModify}">
				<form:input path="script" size="100" disabled="true" />
			</c:if>
    		</td>
  		</tr>
	</table>
	<form:hidden path="ad"/>
	<form:hidden path="id"/>
	<form:hidden path="aetid"/>
	<form:hidden path="eid"/>
	<input type="hidden" name="EV_CSRF_NONCE_Token" value="${EV_CSRF_NONCE_Token}" />
	<c:if test="${scriptActionForm.canModify}">
		<table width="100%" cellpadding="5" cellspacing="0" border="0" class="ToolbarContent">
  			<tr>
  				<td align="center">
  					<input type="image" src="/images/tbb_set.gif" border="0" alt="<fmt:message key='FormButtons.ClickToOk'/>" name="ok" style="padding-right: 5px;"/>
    				<input type="image"  src="/images/tbb_remove.gif" border="0" alt="<fmt:message key='FormButtons.ClickToDelete'/>" name="delete" style="padding-left: 5px;"/>
    			</td>
    		</tr>
		</table>
	</c:if>
</form:form>
