<%@ page language="java" %>
<%@ page errorPage="/common/Error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<!--%@ taglib uri="http://struts.apache.org/tags-html-el" prefix="html" %-->
<!--%@ taglib uri="http://struts.apache.org/tags-tiles" prefix="tiles" %-->
<!--%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic" %-->

<%@ taglib uri="http://tiles.apache.org/tags-tiles" prefix="tiles2" %>
<%@ taglib uri="http://www.springframework.org/tags/form" prefix="form" %>

<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib tagdir="/WEB-INF/tags/jsUtils" prefix="jsu" %>

<c:url var="spacerGif" value="/images/spacer.gif" />
<c:url var="editGroupActionUrl" value="/alerts/EditGroup.do" />
<c:url var="newGroupActionUrl" value="/alerts/NewGroup.do" />

<c:choose>
  <c:when test="${GroupAlertDefinitionForm.ad != 0}">
    <c:set var="actionUrl" value="${editGroupActionUrl}"/>
  </c:when>
  <c:otherwise>
    <c:set var="actionUrl" value="${newGroupActionUrl}"/>
  </c:otherwise>
</c:choose>
<script>
         function showSize(){
          var ta = document.getElementById("description");
          var str = ta.value;
          //var str2 = str.replace(/(?:\\[rn]|[\r\n])/g,"%");
          //var str2 = str.replace(/(?:\\[r]|[\r])/g,"");
          var str2 = str.replace(/(?:\\[rn]|[\r\n])/g,"%");
          //alert(str2);
          //alert(str2.length);

          var dv = document.getElementById("description_validation");
          dv.value= str2;
         }
</script>
<form:form action="${actionUrl}" modelAttribute="GroupAlertDefinitionForm" enctype="multipart/form-data" onsubmit="showSize()">

<tiles2:insertDefinition name=".page.title.events">
  <c:choose>
    <c:when test="${GroupAlertDefinitionForm.ad != 0}">
      <tiles2:putAttribute name="titleKey" value="alert.config.props.ViewDef.PageTitle"/>
    </c:when>
    <c:otherwise>
      <tiles2:putAttribute name="titleKey" value="alert.config.edit.NewAlertDef.PageTitle"/>
    </c:otherwise>
  </c:choose>
</tiles2:insertDefinition>

<tiles2:insertDefinition name=".portlet.error"/>

<form:hidden path="eid"/>
<c:if test="${not empty param.ad}">
<form:hidden path="ad"/>
</c:if>

<tiles2:insertDefinition name=".events.config.new.properties"/>

<tiles2:insertDefinition name=".header.tab">
<tiles2:putAttribute name="tabKey" value="alert.config.props.CondBox"/>
</tiles2:insertDefinition>

<table width="100%" border="0" cellspacing="0" cellpadding="4">
  <tr>
    <td width="20%" class=BlockLabel><html:img page="/images/icon_required.gif" height="9" width="9" border="0"/>
    </td>
    <td class="BlockContent">
    <fmt:message key="resource.group.alerts.config.num.members">
      <fmt:param value="${GroupAlertDefinitionForm.groupSize}"/>
    </fmt:message>
    </td>
  </tr>
  <tr>
    <td class=BlockLabel><fmt:message key="alert.config.props.CB.label.numberOfResourceMembers"/></td>
    <td class="BlockContent">
<form:select path="sizeComparator">
   <form:option value="0">&lt;</form:option>
   <form:option value="1">&gt;</form:option>
</form:select>

<form:input size="5" maxlength="5" path="resourceCount"/>

<form:select path="percentOrAbsolute">
   <form:option value="0"><fmt:message key="alert.config.props.CB.ByPercentage"/></form:option>
   <form:option value="1"><fmt:message key="alert.config.props.CB.ByAbsoluteValue"/></form:option>
</form:select>
     
    </td>
  </tr>
  <tr>
    <td class=BlockLabel><fmt:message key="alert.config.props.CB.label.criteria"/></td>

<c:if test="${metricValWrong}"><td class="ErrorField"></c:if>
<c:if test="${!metricValWrong}"><td class="BlockContent"></c:if>
    <!--logic:messagesPresent property="metricVal"><td class="ErrorField"></logic:messagesPresent-->
    <!--logic:messagesNotPresent property="metricVal"><td class="BlockContent"></logic:messagesNotPresent-->

<!--html:optionsCollection property="templates"/-->
<form:select path="template">
  <form:options items="${GroupAlertDefinitionForm.templates}" itemLabel="label" itemValue="value"/>
  
</form:select>

<!--html:optionsCollection property="operators"/-->
<form:select path="operator">
  <form:options items="${GroupAlertDefinitionForm.operators}" itemLabel="label" itemValue="value"/>
</form:select> 

<form:input size="8" maxlength="25" path="metricVal"/>
    <!--logic:messagesPresent property="metricVal"-->
    <c:if test="${metricValWrong}">
    <span class="ErrorFieldContent">- <form:errors path="metricVal"/></span>
    </c:if>
    <!--/logic:messagesPresent-->
    </td>
  </tr>
  <tr>
    <td class="BlockLabel"></td>
    <td class="BlockContent">
        <form:checkbox path="isNotReportingOffending" /><fmt:message key="alert.config.props.TriggerNotReporting"/>
    </td>
  </tr>
  <tr>
    <td colspan="2" class="BlockContent"><img src="${spacerGif}" height="1" width="1" border="0"></td>
  </tr>
  <tr>
    <td colspan="2" class="BlockBottomLine"><img src="${spacerGif}" height="1" width="1" border="0"></td>
  </tr>
</table>

<c:if test="${empty param.ad}">
<br/>

<tiles2:insertDefinition name=".header.tab">
<tiles2:putAttribute name="tabKey" value="alert.current.detail.notify.Tab"/>
</tiles2:insertDefinition>

<table width="100%" border="0" cellspacing="0" cellpadding="4">
  <tr>
    <td colspan="2" class="BlockContent"><img src="${spacerGif}" height="1" width="1" border="0"></td>
  </tr>
  <tr>
    <td class=BlockLabel width="20%"><fmt:message key="alert.config.escalation.scheme"/></td>
    <td class="BlockContent">
	    <select name="escId" id="escIdSel">
	    </select>
		<jsu:script>
	    	function addOption(sel, val, txt) {
		        var o = document.createElement('option');
	    	    var t = document.createTextNode(txt);
	
	        	o.setAttribute('value',val);
	
		        sel.appendChild(o);
	    	    o.appendChild(document.createTextNode(txt));
		    }
	
			var escJson = eval( '( { "escalations":<c:out value="${escalations}" escapeXml="false"/> })' );
			var schemes = escJson.escalations;
	  		var escalationSel = hqDojo.byId('escIdSel');
	  
	  		for (var i = 0; i < schemes.length; i++) {
	  		if(schemes[i].id=='100' && schemes[i].name=='Default Escalation'){
	    		addOption(escalationSel , schemes[i].id, '<fmt:message key="alert.config.escalation.defaultEscalationName"/>');
	    	}else{
	    	    addOption(escalationSel , schemes[i].id, schemes[i].name);
	    	}
	  		}
		</jsu:script>
    </td>
  </tr>
  <tr>
    <td colspan="2" class="BlockContent"><img src="${spacerGif}" height="1" width="1" border="0"></td>
  </tr>
  <tr>
    <td colspan="2" class="BlockBottomLine"><img src="${spacerGif}" height="1" width="1" border="0"></td>
  </tr>
</table>
</c:if>

<tiles2:insertDefinition name=".events.config.form.buttons"/>

<tiles2:insertDefinition name=".page.footer"/>
<input type="hidden" name="EV_CSRF_NONCE_Token" value="${EV_CSRF_NONCE_Token}" />
</form:form>

