<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://www.springframework.org/tags/form" prefix="form" %>
<%@ taglib uri="http://tiles.apache.org/tags-tiles" prefix="tiles2"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<%--
  NOTE: This copyright does *not* cover user programs that use HQ
  program services by normal system calls through the application
  program interfaces provided as part of the Hyperic Plug-in Development
  Kit or the Hyperic Client Development Kit - this is merely considered
  normal use of the program, and does *not* fall under the heading of
  "derived work".
  
  Copyright (C) [2004, 2005, 2006], Hyperic, Inc.
  This file is part of HQ.
  
  HQ is free software; you can redistribute it and/or modify
  it under the terms version 2 of the GNU General Public License as
  published by the Free Software Foundation. This program is distributed
  in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
  even the implied warranty of MERCHANTABILITY or FITNESS FOR A
  PARTICULAR PURPOSE. See the GNU General Public License for more
  details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA.
 --%>


<tiles2:insertDefinition name=".page.title.resource.platform">
  <tiles2:putAttribute name="titleName" value="${Resource.name}"/>
</tiles2:insertDefinition>

<c:url var="selfAction" value="/resource/platform/AutoDiscovery.do?mode=edit"/>
<c:url var="PlatformAutoDiscoveryFormAction" value="/resource/platform/autodiscovery/EditAutoDiscovery.do"/>
<form:form modelAttribute="PlatformAutoDiscoveryForm" action="${PlatformAutoDiscoveryFormAction}">
<form:hidden path="rid"/>
<form:hidden path="type"/>
<form:hidden path="sid"/>
<input type="hidden" name="EV_CSRF_NONCE_Token" value="${EV_CSRF_NONCE_Token}" />    
<tiles2:insertDefinition name=".portlet.confirm"/>
<tiles2:insertDefinition name=".portlet.error"/>

<tiles2:insertTemplate template="/resource/platform/autodiscovery/AutoDiscoveryPropertiesForm.jsp"/>
&nbsp;<br>

<tiles2:insertTemplate template="/resource/platform/autodiscovery/ScanPropertiesForm.jsp">
    <tiles2:putAttribute name="selfAction" value="${selfAction}"/>
</tiles2:insertTemplate>
&nbsp;<br>

<!-- SCHEDULE ACTION PROPERTIES -->
<c:if test="${not onlyAIplatform}">
  <tiles2:insertDefinition name=".schedule"/>
</c:if>

<tiles2:insertDefinition name=".form.buttons"/>

<tiles2:insertDefinition name=".page.footer"/>
	
</form:form>
