<%@ page language="java" %>
<%@ page errorPage="/common/Error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://www.springframework.org/tags/form" prefix="form" %>
<%@ taglib uri="http://tiles.apache.org/tags-tiles" prefix="tiles" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<c:url var="AddResourceGroupsUrl" value="/admin/role/AddResourceGroups.do"/>
<form:form action="${AddResourceGroupsUrl}" method="POST" modelAttribute="AddResourceGroupsForm">
<input type="hidden" name="EV_CSRF_NONCE_Token" value="${EV_CSRF_NONCE_Token}" />
<tiles:insertDefinition name=".page.title.admin.role">
  <tiles:putAttribute name="titleKey" value="admin.role.add.groups"/>
  <tiles:putAttribute name="titleName" value="${Role.name}"/>
</tiles:insertDefinition>

<tiles:insertDefinition name=".portlet.error"/>

<tiles:insertTemplate template="/admin/role/RoleGroupsForm.jsp">
  <tiles:putAttribute name="availableResGrps" value="${AvailableResGrps}"/>
  <tiles:putAttribute name="numAvailableResGrps" value="${NumAvailableResGrps}"/>
  <tiles:putAttribute name="pendingResGrps" value="${PendingResGrps}"/>
  <tiles:putAttribute name="numPendingResGrps" value="${NumPendingResGrps}"/>
</tiles:insertTemplate>

<tiles:insertDefinition name=".form.buttons">
  <tiles:putAttribute name="addToList" value="true"/>
</tiles:insertDefinition>

<tiles:insertDefinition name=".page.footer"/>

<input type="hidden" name="r" value="${Role.id}"/>
</form:form>
