<%@ page pageEncoding="UTF-8"%>
<%@ page language="java" contentType="text/html; charset=UTF-8" %>
<%@ page errorPage="/common/Error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://tiles.apache.org/tags-tiles" prefix="tiles2" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib uri="/WEB-INF/tld/hq.tld" prefix="hq" %>
<%@ taglib tagdir="/WEB-INF/tags/jsUtils" prefix="jsu" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%--
  NOTE: This copyright does *not* cover user programs that use HQ
  program services by normal system calls through the application
  program interfaces provided as part of the Hyperic Plug-in Development
  Kit or the Hyperic Client Development Kit - this is merely considered
  normal use of the program, and does *not* fall under the heading of
  "derived work".
  
  Copyright (C) [2004-2009], Hyperic, Inc.
  This file is part of HQ.
  
  HQ is free software; you can redistribute it and/or modify
  it under the terms version 2 of the GNU General Public License as
  published by the Free Software Foundation. This program is distributed
  in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
  even the implied warranty of MERCHANTABILITY or FITNESS FOR A
  PARTICULAR PURPOSE. See the GNU General Public License for more
  details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA.
 --%>

<jsu:importScript path="/js/requests.js" />
<hq:Timeout />
<jsu:importScript path="/js/lib/lib.js" />
<jsu:script>
	alertTitlestr = '<fmt:message key='resoure.Alert.action.title'/>';
	alertFixHintstr = '<fmt:message key='resoure.Alert.action.fixhint'/>';
  alertFixPrevStr = '<fmt:message key='resoure.Alert.action.fixprevious'/>';
  alertBtnFixed = '<fmt:message key='resoure.Alert.action.fix'/>';
  alertactHintstr = '<fmt:message key='resoure.Alert.action.acthint'/>'; 
  alertPauseEscStr = '<fmt:message key='resoure.Alert.action.pauseEscalation'/>'; 
	alertBtnAct = '<fmt:message key='resoure.Alert.action.ack'/>';
	alertBtnProcess = '<fmt:message key='resoure.Alert.action.process'/>';
	actStr=alertBtnAct;
</jsu:script>	
<jsu:script>
	var evwindow;
	function opennew(winurl,title){
	  if(!evwindow || evwindow.closed)
	  {
		  evwindow = window.open(winurl,title,'width=800,height=650,scrollbars=yes,toolbar=yes,location=yes,left=80,top=80,resizable=yes');
	  }
	  else {
		  evwindow.focus();
	  }
	}
    function getUpdateStatus(opt) {
        if (opt == "<fmt:message key="header.Acknowledge"/>") {
        	var postData = { update: true};
            var updateUrl = '<c:url value="/Dashboard.do"/>';
            hqDojo.xhrPost({
         	 	url: updateUrl,
         	 	content: postData,
         	 	load: function(data) {
         	 	hqDojo.style("updateLink", "display", "none");
         	 	updateDialog.hide();
        		}
       		});
        }
    }
    
    var resourceURL = '<c:url value="/Resource.do"/>';
	var userURL = '<c:url value="/admin/user/UserAdmin.do"/>';
    var searchWidget = new hyperic.widget.search(hqDojo, {search:'/app/search'}, 3, {keyCode: 83, ctrl: true});
    var refreshCount = 0;
                                                                                  
	function refreshAlerts() {
    	refreshCount++;
	
    	hqDojo.xhrGet({
    		url: "<c:url value="/common/RecentAlerts.jsp"/>",
    		load: showRecentAlertResponse
    	});
    }

    function showRecentAlertResponse(response, args) {
      	if (response.indexOf('recentAlertsText') > 0) {
        	hqDojo.style("headerAlerts", "display", "");
        	hqDojo.byId("recentAlerts").innerHTML = response;
      	} else {
        	refreshCount = 31;
      	}

      	if (refreshCount < 30) {
        	setTimeout( "refreshAlerts()", portlets_reload_time );
      	} else if (autoLogout) {
    	  	top.location.href = "<c:url value="/j_spring_security_logout"/>";
      	}
    }

    var useBreadcrumbHrefIfAvailable = function(link) {
		var browseInput = hqDojo.byId("browseUrlInput"); // Generated by bread crumb tag

		if (browseInput != null) {
			 var url = browseInput.value;

			 if (url != null && url.length > 0) {
				 link.href = url;
			 }		 
		}
    }
    
    var showSubMenu = function(menuId){
		var subMenu = hqDojo.byId(menuId);
		if(subMenu != null){
			subMenu.style.display='block';
		}
	}

	var hideSubMenu = function(menuId){
		var subMenu = hqDojo.byId(menuId);
		if(subMenu != null){
			subMenu.style.display='none';
		}
	}

	var bindArrow = function(keyCode,menuId){
		if(keyCode==40){
			if(hqDojo.byId(menuId).style.display==''||hqDojo.byId(menuId).style.display=='none'){
				showSubMenu(menuId);
			}else{
				hqDojo.query("a",hqDojo.query("li", hqDojo.byId(menuId))[0])[0].focus();
				hqDojo.addClass(hqDojo.query("li", hqDojo.byId(menuId))[0], "over currentMenuItem");
				hqDojo.addClass(hqDojo.query("a",hqDojo.query("li", hqDojo.byId(menuId))[0])[0], "subMenuItem");
			}
		}else if(keyCode==38){
			hideSubMenu(menuId);
		}
	}
    
    hqDojo.require("dijit.dijit");
 	hqDojo.require("dijit.Dialog");
 	 		
 	var updateDialog = null;
</jsu:script>
<jsu:script onLoad="true">
    activateHeaderTab(hqDojo);
    searchWidget.create();
    
    //Connect the events for the box, cancel and search buttons
    hqDojo.connect(searchWidget.searchBox, "onkeypress", searchWidget, "search");
    
    // What should the hot-keys do?
    hqDojo.subscribe('enter', searchWidget, "search");
        
	// update the SAS timeout after XHR calls complete
	hqDojo.config.ioPublish = true;
    hqDojo.subscribe("/dojo/io/done", function() {
		sas_framework_updateTimeout();
    });  
            
    refreshAlerts();
</jsu:script>
    <div id="header">
    <!--
    <div id="headerLogo" title="Home" onclick="location.href='<html:rewrite action="/Dashboard" />'">&nbsp;</div>
    <div id="headerLogoZ" title="Home" onclick="location.href='<html:rewrite action="/Dashboard" />'">
                 <span id="headerTitle" ><fmt:message key="header.product.name"/></span>
        </div>
    -->
        <div id="headerLogoZ" title="Home" onclick="location.href='<c:url value="/Dashboard.do" />'">
             <span id="headerTitle" >
             <fmt:message key="header.product.name"/>
             </span>
        </div>

   
    <div class="ajaxLoading" style="display:none;" id="loading">
        <img src="/images/4.0/icons/ajax-loader.gif" border="0" width="16" height="16"/>
    </div>
    <div id="headerAlerts" style="display:none;">
      <div class="headAlertWrapper">
        <div class="recentText">
          <fmt:message key="header.RecentAlerts"/>
        </div>
        <br/>
        <div id="recentAlerts"></div>
      </div>
    </div>
    <div id="headerLinks">
 	 	<c:if test="${not empty HQUpdateReport}">
 	 	<div id="update" class="dialog" style="display: none;">
 	 	<c:out value="${HQUpdateReport}" escapeXml="false"/>
 	 
 	 	<form name="updateForm" action="">
 	 		<div style="text-align:right;">
 	 			<input type="button" class="button42" value="<fmt:message key="header.Acknowledge"/>" onclick="getUpdateStatus(this.value);">
 	 		</div>
 	 	</form>
 	</div>
 	<jsu:script onLoad="true">
 	 	updateDialog = new hqDijit.Dialog({
 	 	 	id: 'update_popup',
 	 		refocus: true,
 	 		autofocus: false,
 	 		opacity: 0,
 	 		title: "<fmt:message key="header.dialog.title.update" />"
 			}, hqDojo.byId('update'));
 	</jsu:script>
 	<a id="updateLink" href="javascript:updateDialog.show()">
 		<img src="/images/transmit2.gif" align="absMiddle" border="0" />                        
 	</a>
	</c:if>	
        
        <c:set value="0" var="tabIndex" />
         <c:choose>
            <c:when test="${useroperations['viewSubject']}">
            	<c:set value="${tabIndex+1}" var="tabIndex" />
                <c:url var="a_linkurl1" value="/admin/user/UserAdmin.do">
                	<c:param name="mode" value="view"/>
                	<c:param name="u" value="${sessionScope.webUser.id}"/>
                </c:url>
                <a href="${a_linkurl1}" title="<fmt:message key='header.Welcome'/> ${fn:escapeXml(sessionScope.webUser.firstName)}" alt="<fmt:message key='header.Welcome'/> ${fn:escapeXml(sessionScope.webUser.firstName)}">
                    <span class="icon-user" id="welcomeWebUserSpan" data-line="${fn:substring(sessionScope.webUser.firstName, 0, 1)}"></span>
                </a>
            </c:when>
            <c:otherwise>
                <span class="icon-user" title="<fmt:message key='header.Welcome'/> ${sessionScope.webUser.firstName}" alt="<fmt:message key='header.Welcome'/> ${sessionScope.webUser.firstName}" id="welcomeWebUserSpan" data-line="${fn:substring(sessionScope.webUser.firstName, 0, 1)}"></span>
            </c:otherwise>
        </c:choose>
        <c:set value="${tabIndex+1}" var="tabIndex" />
        <a href="<c:url value="/j_spring_security_logout"/>" tabindex="${tabIndex}" title="<fmt:message key='header.SignOut'/>" alt="<fmt:message key='header.SignOut'/>">
        <span class="icon-signout" id="signoutLinkSpan"></span>
        </a>        <c:set value="${tabIndex+1}" var="tabIndex" />
        
        <a id="hqHelpLink" href="<hq:help/>" onclick="helpWin=window.open((typeof help != 'undefined' ? help : this.href),'SASDoc','width=800,height=650,scrollbars=yes,toolbar=yes,left=80,top=80,resizable=yes');helpWin.focus();return false;" tabindex="${tabIndex}" title="<fmt:message key='header.Help'/>" alt="<fmt:message key='header.Help'/>"><span class="icon-help" id="helpLinkSpan"></span></a>
    </div>
    <div id="headerSearch">
    	<c:set value="${tabIndex+1}" var="tabIndex" />
		<input type="text" id="searchBox" value="" alt="<fmt:message key='header.Search'/>" tabindex="${tabIndex}"/>
    </div>
	<div id="headerSearchResults" style="display:none">
      	<div id="searchClose" class="cancelButton right"></div>
	        <div class="resultsGroup">
       		    <div class="category"><fmt:message key="header.Resources"/> (<span id="resourceResultsCount"></span>)</div>
	           	<ul id="resourceResults">
           		    <li></li>
		        </ul>
		    </div>
		    <div class="resultsGroup">
           		<div class="category"><fmt:message key="header.users"/> (<span id="usersResultsCount"></span>)</div>
		        <ul id="usersResults">
               		<li></li>
           		</ul>
       		</div>
    	</div>

		 <div id="navTabContainer">
        <c:set var="pageURL" value="${requestURL}"/>
        <div id="dashTab" class="tab">
			<c:set value="${tabIndex+1}" var="tabIndex" />
        	<a href="<c:url value="/Dashboard.do"/>" tabindex="${tabIndex}"><fmt:message key="header.dashboard"/></a>
        </div>
        <div id="resTab" class="tab">
			<c:set value="${tabIndex+1}" var="tabIndex" />
        	<a href="<c:url value="/ResourceHub.do"/>" tabindex="${tabIndex}" onclick="useBreadcrumbHrefIfAvailable(this);" onkeyup="bindArrow(event.keyCode,'resourceSubMenu');"><fmt:message key="header.resources"/></a>
        	<ul class="root" id="resourceSubMenu">
        		<li>
        			<a href="<c:url value="/ResourceHub.do"/>" onclick="useBreadcrumbHrefIfAvailable(this);"><fmt:message key="header.Browse"/></a>
        		</li>
                <tiles2:insertDefinition name=".header.optional.tabs">
                	<tiles2:putAttribute name="location" value="resources"/>
                </tiles2:insertDefinition>
                <li class="hasSubmenu">
                	<a href="#"><fmt:message key=".dashContent.recentResources"/></a>
                  	<ul>
                    	<tiles2:insertDefinition name=".toolbar.recentResources"/>
                  	</ul>
                </li>
        	</ul>
        </div>
        <div id="analyzeTab" class="tab">
			<c:set value="${tabIndex+1}" var="tabIndex" />
        	<a href="#" onkeyup="hideSubMenu('resourceSubMenu');bindArrow(event.keyCode,'analyzeSubMenu');" tabindex="${tabIndex}"><fmt:message key="header.analyze"/></a>
        	<ul class="root" id="analyzeSubMenu">
              	<tiles2:insertDefinition name=".header.optional.tabs">
                  	<tiles2:putAttribute name="location" value="tracking"/>
              	</tiles2:insertDefinition>
          	</ul>
        </div>
        <div id="evTab" class="tab" onkeyup="hideSubMenu('analyzeSubMenu');">    
				<c:set value="${tabIndex+1}" var="tabIndex" />
				<c:set var="evurl"><%= application.getInitParameter("ModuleFrameworkURL") %></c:set>
				<c:set var="winNum"><%= (int)(Math.random()*1000) %></c:set>
        <a href="${evurl}" onclick="opennew('<c:out value="${evurl}" />','SASEV_${winNum}');return false;" tabindex="${tabIndex}"><fmt:message key="header.ev"/></a>     		
	    </div>
        <div id="adminTab" class="tab">
			<c:set value="${tabIndex+1}" var="tabIndex" />
        	<a href="<c:url value="/Admin.do"/>" tabindex="${tabIndex}"><fmt:message key="header.admin"/></a>
        </div>
    </div>
    <jsu:script onLoad="true">
    	var menu = hqDojo.byId("navTabContainer");
	    	
    	hqDojo.query(".tab", menu).onmouseleave(function(e) {
    		hqDojo.removeClass(e.currentTarget, "over");	
			hideSubMenu('resourceSubMenu');
			hideSubMenu('analyzeSubMenu');
			
    	}).onmouseenter(function(e) {
    		hqDojo.addClass(e.currentTarget, "over");			
			showSubMenu(e.currentTarget.getElementsByTagName("ul")[0].id);
    	});
	    	
    	hqDojo.query("li", menu).onmouseover(function(e) {	
    		hqDojo.addClass(e.currentTarget, "over");
    	}).onmouseout(function(e) {
    		hqDojo.removeClass(e.currentTarget, "over")
    	});
		
			var changeFocusInSubMenu = function(e,subMenu,isRootSubMenu){
			
			var items = hqDojo.query(">li", subMenu);			
			var currentItem = hqDojo.query(">.currentMenuItem",subMenu)[0];		
			var currentLink = hqDojo.query("a",currentItem)[0];			
			if(e.keyCode==9){				
				hqDojo.removeClass(hqDojo.query("a",currentItem)[0], "subMenuItem");
				hqDojo.removeClass(currentItem, "over currentMenuItem");
				if(isRootSubMenu){
					hideSubMenu(subMenu.id);					
					var preParentTabIndex = hqDojo.query(">a",hqDojo.byId(subMenu.id).parentNode)[0].tabIndex-1;										
					var preMainItem = hqDojo.query("a[tabIndex='"+preParentTabIndex+"']]")[0];					
					preMainItem.focus();					
				}
			}
			if(currentLink==document.activeElement){
				var currentPosition = 0;
				for(var i=0;i < items.length;i++){					
					if(items[i]==currentItem){						
						currentPosition = i;
					}
				}
				if(e.keyCode==37){					
					if(!isRootSubMenu&&currentPosition==0){
						hqDojo.removeClass(hqDojo.query("a",currentItem)[0], "subMenuItem");	
						hqDojo.removeClass(currentItem, "over currentMenuItem");	
						hqDojo.addClass(subMenu.parentNode, "over");
						hqDojo.addClass(hqDojo.query("a",subMenu.parentNode)[0], "subMenuItem");
						hqDojo.query("a",subMenu.parentNode)[0].focus();
					}	
				}else if(e.keyCode==38){					
					if(isRootSubMenu&&currentPosition==0){						
						hqDojo.removeClass(hqDojo.query("a",currentItem)[0], "subMenuItem");
						hqDojo.removeClass(currentItem, "over currentMenuItem");
						hideSubMenu(subMenu.id);
						hqDojo.query("a",subMenu.parentNode)[0].focus();
					}else if(currentPosition>0){
						selectMenu(currentPosition,-1,items);
					}
				}else if(e.keyCode==39){
					if(currentItem.className!=null&&currentItem.className.indexOf("hasSubmenu")>-1){
						var secondLevelMenu = hqDojo.query(">ul",currentItem)[0];
						var secondLevelMenuItems = hqDojo.query(">li", secondLevelMenu);
						hqDojo.query("a",secondLevelMenuItems[0])[0].focus();
						hqDojo.addClass(secondLevelMenuItems[0], "over currentMenuItem");
						hqDojo.addClass(hqDojo.query("a",secondLevelMenuItems[0])[0], "subMenuItem");
						hqDojo.removeClass(hqDojo.query("a",currentItem)[0], "subMenuItem");
					}
				}else if(e.keyCode==40){					
					if(currentPosition < items.length-1){	
						selectMenu(currentPosition,1,items);
					}
				}
			}			
		}			

		var selectMenu = function(currentPosition,offset,obj){
		   currentPosition = currentPosition+offset;
		   hqDojo.query("a",obj[currentPosition])[0].focus();		   
           hqDojo.addClass(obj[currentPosition], "over currentMenuItem");
		   hqDojo.addClass(hqDojo.query("a",obj[currentPosition])[0], "subMenuItem ");
		   hqDojo.removeClass(hqDojo.query("a",obj[currentPosition-offset])[0], "subMenuItem");				  					
		   hqDojo.removeClass(obj[currentPosition-offset], "over currentMenuItem");
       }
	   
	
	   var recBind = function(subMenu,isRootSubMenu){			
			if(hqDojo.query(">li.hasSubmenu", subMenu)!=null&&hqDojo.query(">li.hasSubmenu", subMenu).length>0){
				var menus = hqDojo.query(">li.hasSubmenu", subMenu);
				for(var j=0; j < menus.length; j++){
					var ul = hqDojo.query(">ul", menus[j])[0];						
					recBind(ul,false);
				}
			}			
			hqDojo.query(">li", subMenu).onkeydown(function(e){changeFocusInSubMenu(e,subMenu,isRootSubMenu);});
	   }	   
		
		recBind(hqDojo.byId("resourceSubMenu"),true);
		recBind(hqDojo.byId("analyzeSubMenu"),true);
		
		var welcomeWebUserSpan = hqDojo.byId("welcomeWebUserSpan");
		var signoutLinkSpan = hqDojo.byId("signoutLinkSpan");
		var helpLinkSpan = hqDojo.byId("helpLinkSpan");
		var isIE = false;
		if (navigator.appName.indexOf("Microsoft")!=-1) {
			if(welcomeWebUserSpan.title){
				welcomeWebUserSpan.innerHTML=welcomeWebUserSpan.title;
			}else{
				welcomeWebUserSpan.innerHTML=welcomeWebUserSpan.parentNode.title;
			}
			signoutLinkSpan.innerHTML=signoutLinkSpan.parentNode.title;
			helpLinkSpan.innerHTML=helpLinkSpan.parentNode.title;
			welcomeWebUserSpan.style.textDecoration="underline";
			signoutLinkSpan.style.textDecoration="underline";
			helpLinkSpan.style.textDecoration="underline";
			welcomeWebUserSpan.style.cursor="pointer";
			signoutLinkSpan.style.cursor="pointer";
			helpLinkSpan.style.cursor="pointer";
			hqDojo.byId("headerSearch").style.right=hqDojo.byId("headerLinks").offsetWidth+40;
			hqDojo.byId("headerSearchResults").style.right=hqDojo.byId("headerLinks").offsetWidth+40;
		}
	</jsu:script>
    </div>
