<%@ page language="java" %>
<%@ page errorPage="/common/Error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://www.springframework.org/tags/form" prefix="form" %>
<%@ taglib uri="http://tiles.apache.org/tags-tiles" prefix="tiles2" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="/WEB-INF/tld/hq.tld" prefix="hq" %>
<%@ taglib uri="/WEB-INF/tld/display.tld" prefix="display" %>
<%@ taglib tagdir="/WEB-INF/tags/jsUtils" prefix="jsu" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>

<tiles2:importAttribute name="portletName"/>
<hq:pageSize var="pageSize"/>
<c:set var="widgetInstanceName" value="resources"/>
<c:url var="selfAction" value="/dashboard/Admin.do">
	<c:param name="mode" value="resourceHealth"/>
</c:url>
<jsu:importScript path="/js/listWidget.js" />
<jsu:script>
	var pageData = new Array();
	initializeWidgetProperties('<c:out value="${widgetInstanceName}"/>');
	widgetProperties = getWidgetProperties('<c:out value="${widgetInstanceName}"/>');  
	var help = '<hq:help/>';
</jsu:script>
<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr class="PageTitle"> 
    <td rowspan="99"><img src="/images/spacer.gif" width="5" height="1" alt="" border="0"/></td>
    <td><img src="/images/spacer.gif" width="15" height="1" alt="" border="0"/></td>
    <td width="67%" class="PortletTitle"><fmt:message key="dash.home.ProblemResources.Settings.Title"/></td>
    <td width="32%"><img src="/images/spacer.gif" width="202" height="32" alt="" border="0"/></td>
    <td width="1%"><img src="/images/spacer.gif" width="1" height="1" alt="" border="0"/></td>
  </tr>
  <tr> 
    <td valign="top" align="left" rowspan="99"></td>
    <td colspan="3"><img src="/images/spacer.gif" width="1" height="10" alt="" border="0"/></td>
  </tr>
  <tr valign="top"> 
    <td colspan="2">
      <c:url var="f_formurl1" value="/dashboard/ModifyProblemResources.do"/>
      <form:form modelAttribute="ProblemResourcesForm" action="${f_formurl1}" >
<div id="narrowlist_false">
      <tiles2:insertDefinition name=".header.tab">
        <tiles2:putAttribute name="tabKey" value="dash.settings.DisplaySettings"/>
      </tiles2:insertDefinition>
</div>
      <tiles2:insertDefinition name=".dashContent.admin.generalSettings">
        <tiles2:putAttribute name="portletName" value="${portletName}" />
      </tiles2:insertDefinition>

      <table width="100%" cellpadding="0" cellspacing="0" border="0">  
        <tr>
          <td colspan="4" class="BlockContent"><img src="/images/spacer.gif" width="1" height="1" border="0"/></td>
        </tr>
        <tr valign="top">
          <td width="50%" class="BlockLabel" valign="center"><fmt:message key="dash.settings.FormLabel.ProblemResources.numberOnDashboard"/></td>
          <td>
          	  <form:select path="rows" disabled="${not sessionScope.modifyDashboard}" >
                <form:option value="5">5</form:option>
                <form:option value="10">10</form:option>
                <form:option value="15">15</form:option>
                <form:option value="20">20</form:option>
                <form:option value="30">30</form:option>
              </form:select>
          </td>
          <td width="80%" class="BlockContent" valign="center">
            &nbsp;
          </td>
        </tr>
        <tr>
          <td colspan="3" class="BlockContent"><img src="/images/spacer.gif" width="1" height="1" border="0"/></td>
        </tr>
        <tr>
          <td width="50%" class="BlockLabel" valign="center"><fmt:message key="dash.settings.FormLabel.ProblemResources.numberOfHours"/></td>
          <td>
          	  <form:select path="hours" disabled="${not sessionScope.modifyDashboard}" >
                <form:option value="1">1</form:option>
                <form:option value="4">4</form:option>
                <form:option value="8">8</form:option>
                <form:option value="24">24</form:option>
                <form:option value="48">48</form:option>
              </form:select>
          </td>
          <td width="80%" class="BlockContent" valign="center">
            &nbsp;
          </td>
        </tr>
        <tr>
          <td colspan="3" class="BlockContent"><img src="/images/spacer.gif" width="1" height="1" border="0"/></td>
        </tr>
        <tr>
          <td colspan="3" class="BlockBottomLine"><img src="/images/spacer.gif" width="1" height="1" border="0"/></td>
        </tr>
      </table>
      &nbsp;<br>

  <c:if test="${not empty problemResources}">   
      <tiles2:insertDefinition name=".header.tab">
        <tiles2:putAttribute name="tabKey" value="dash.home.ProblemResources"/>
      </tiles2:insertDefinition>
		<c:url var="DashboardTableURL" value="/Dashboard.do"/>
      <display:table cellspacing="0" cellpadding="0" width="100%" action="${DashboardTableURL}"
                   var="resource" pageSize="-1" items="${problemResources}" >
                
        <display:column width="60%" href="/Resource.do?eid=${fn:escapeXml(resource.resourceType)}:${fn:escapeXml(resource.resourceId)}" property="entityName" title="dash.home.TableHeader.ResourceName"/>
      
        <display:column width="10%" property="availability" title="resource.common.monitor.visibility.AvailabilityTH" align="left" >
          <display:availabilitydecorator value="${resource.availability}" 
                                         monitorable="true" />
        </display:column>
        
        <display:column width="10%" property="alertCount" title="dash.home.TableHeader.Alerts" align="left"/>          

        <display:column width="10%" property="oobCount" title="dash.home.TableHeader.OOB" align="left" /> 
        
    </display:table>    
  </c:if>

      <tiles2:insertDefinition name=".form.buttons">
      <c:if test='${not sessionScope.modifyDashboard}'>
        <tiles2:putAttribute name="cancelOnly" value="true"/>
        <tiles2:putAttribute name="noReset" value="true"/>
      </c:if>
      </tiles2:insertDefinition>

      </form:form>

    </td>
  </tr>
  <tr> 
    <td colspan="3"><img src="/images/spacer.gif" width="1" height="13" alt="" border="0"/></td>
  </tr>
</table>
