<%@ page language="java" %>
<%@ page errorPage="/common/Error.jsp" %>
<%@ taglib uri="http://www.springframework.org/tags/form" prefix="form" %>
<%@ taglib uri="http://tiles.apache.org/tags-tiles" prefix="tiles" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<%--
  NOTE: This copyright does *not* cover user programs that use HQ
  program services by normal system calls through the application
  program interfaces provided as part of the Hyperic Plug-in Development
  Kit or the Hyperic Client Development Kit - this is merely considered
  normal use of the program, and does *not* fall under the heading of
  "derived work".
  
  Copyright (C) [2004-2010], VMware, Inc.
  This file is part of Hyperic.
  
  HQ is free software; you can redistribute it and/or modify
  it under the terms version 2 of the GNU General Public License as
  published by the Free Software Foundation. This program is distributed
  in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
  even the implied warranty of MERCHANTABILITY or FITNESS FOR A
  PARTICULAR PURPOSE. See the GNU General Public License for more
  details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA.
 --%>
<c:url var="editDefUrl" value="/alerts/EditConditions.do"/>
<form:form action="${editDefUrl}"  method="POST" enctype="multipart/form-data" modelAttribute="definitionNewForm">
<tiles:insertDefinition name=".page.title.events">
	<tiles:putAttribute name="titleKey" value="alert.config.edit.page.Cond.PageTitle"/>
</tiles:insertDefinition>
<form:hidden path="ad"/>
<c:choose>
  <c:when test="${not empty Resource}">
<form:hidden path="eid" value="${Resource.entityId}"/>
  </c:when>
  <c:otherwise>
<form:hidden path="aetid" value="${ResourceType.appdefTypeKey}"/>
  </c:otherwise>
</c:choose>
<tiles:insertDefinition name=".portlet.error"/>
<tiles:insertDefinition name=".events.config.conditions">
  <tiles:putAttribute name="formName" value="definitionNewForm"/>
  <c:if test="${definitionNewForm.whenEnabled == enableTimePeriod}">
    <tiles:putAttribute name="showDuration" value="true"/>
  </c:if>
</tiles:insertDefinition>

<tiles:insertDefinition name=".form.buttons"/>

<tiles:insertDefinition name=".page.footer"/>
<input type="hidden" name="EV_CSRF_NONCE_Token" value="${EV_CSRF_NONCE_Token}" />
</form:form>
