<%@ page language="java" %>
<%@ page errorPage="/common/Error.jsp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<!--%@ taglib uri="http://struts.apache.org/tags-html-el" prefix="html" %-->
<!--%@ taglib uri="http://struts.apache.org/tags-tiles" prefix="tiles" %-->

<%@ taglib uri="http://tiles.apache.org/tags-tiles" prefix="tiles2" %>
<%@ taglib uri="http://www.springframework.org/tags/form" prefix="form" %>

<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="/WEB-INF/tld/hq.tld" prefix="hq" %>
<%@ taglib uri="/WEB-INF/tld/display.tld" prefix="display" %>
<%@ taglib tagdir="/WEB-INF/tags/jsUtils" prefix="jsu" %>
<%@ taglib uri="https://www.owasp.org/index.php/OWASP_Java_Encoder_Project" prefix="owasp" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%--
  NOTE: This copyright does *not* cover user programs that use HQ
  program services by normal system calls through the application
  program interfaces provided as part of the Hyperic Plug-in Development
  Kit or the Hyperic Client Development Kit - this is merely considered
  normal use of the program, and does *not* fall under the heading of
  "derived work".
  
  Copyright (C) [2004, 2005, 2006], Hyperic, Inc.
  This file is part of HQ.
  
  HQ is free software; you can redistribute it and/or modify
  it under the terms version 2 of the GNU General Public License as
  published by the Free Software Foundation. This program is distributed
  in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
  even the implied warranty of MERCHANTABILITY or FITNESS FOR A
  PARTICULAR PURPOSE. See the GNU General Public License for more
  details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA.
 --%>


<!-- NOT SURE
<tiles2:importAttribute name="resource" ignore="true"/>
-->

<hq:constant
    classname="org.hyperic.hq.appdef.shared.AppdefEntityConstants" 
    symbol="APPDEF_TYPE_PLATFORM" var="CONST_PLATFORM" />
<hq:constant
    classname="org.hyperic.hq.appdef.shared.AppdefEntityConstants" 
    symbol="APPDEF_TYPE_SERVER" var="CONST_SERVER" />
<hq:constant
    classname="org.hyperic.hq.appdef.shared.AppdefEntityConstants" 
    symbol="APPDEF_TYPE_SERVICE" var="CONST_SERVICE" />
<hq:constant
    classname="org.hyperic.hq.appdef.shared.AppdefEntityConstants" 
    symbol="APPDEF_TYPE_APPLICATION" var="CONST_APPLICATION" />
<hq:constant
    classname="org.hyperic.hq.appdef.shared.AppdefEntityConstants" 
    symbol="APPDEF_TYPE_GROUP" var="CONST_GROUP" />

<hq:constant
    classname="org.hyperic.hq.ui.Constants" 
    symbol="CONTROL_ENABLED_ATTR" var="CONST_CONTROLLABLE" /> 

<c:set var="canControl" value="${requestScope[CONST_CONTROLLABLE]}"/>
<jsu:importScript path="/js/listWidget.js" />
<c:set var="widgetInstanceName" value="listAlertDefinitions"/>
<jsu:script>
	function setActiveInactive() {
    	document.RemoveConfigForm.setActiveInactive.value='y';
	    document.RemoveConfigForm.submit();
	}

	var pageData = new Array();
	initializeWidgetProperties('<c:out value="${widgetInstanceName}"/>');
	widgetProperties = getWidgetProperties('<c:out value="${widgetInstanceName}"/>');
</jsu:script>
<c:set var="entityId" value="${Resource.entityId}"/>
<c:url var="action" value="/Config.do" context="/alerts">
  <c:param name="mode" value="list"/>
  <c:param name="rid" value="${Resource.id}"/>
  <c:param name="type" value="${entityId.type}"/>
  <c:if test="${not empty param.ps}">
    <c:param name="ps" value="${owasp:forUriComponent(param.ps)}"/>
  </c:if>
</c:url>
<c:url var="pnAction" value="${action}">
  <c:if test="${not empty param.so}">
    <c:param name="so" value="${owasp:forUriComponent(param.so)}"/>
  </c:if>
  <c:if test="${not empty param.sc}">
    <c:param name="sc" value="${owasp:forUriComponent(param.sc)}"/>
  </c:if>
</c:url>
<c:url var="psAction" value="${action}">
  <c:if test="${not empty param.so}">
    <c:param name="so" value="${owasp:forUriComponent(param.so)}"/>
  </c:if>
  <c:if test="${not empty param.sc}">
    <c:param name="sc" value="${owasp:forUriComponent(param.sc)}"/>
  </c:if>
</c:url>
<c:url var="sortAction" value="${action}">
  <c:if test="${not empty param.pn}">
    <c:param name="pn" value="${owasp:forUriComponent(param.pn)}"/>
  </c:if>
</c:url>
<c:set var="newAction" value="/alerts/Config.do?mode=new&eid=${entityId.appdefKey}"/>

<c:set var="entityId" value="${Resource.entityId}"/>


<tiles2:insertDefinition name=".page.title.resource.group.full">
  <tiles2:putAttribute name="resource" value="${Resource}"/>
  <tiles2:putAttribute name="resourceOwner" value="${ResourceOwner}"/>
  <tiles2:putAttribute name="resourceModifier" value="${ResourceModifier}"/>
  <tiles2:putAttribute name="eid" value="${entityId.appdefKey}" />
</tiles2:insertDefinition>
    <c:choose>
        <c:when test="${ canControl }">
            <tiles2:insertDefinition name=".tabs.resource.group.alert.configAlerts">
                <tiles2:putAttribute name="resourceId" value="${Resource.id}" />
                <tiles2:putAttribute name="resourceType" value="${entityId.type}" />
            </tiles2:insertDefinition>
        </c:when>
        <c:otherwise>
            <tiles2:insertDefinition name=".tabs.resource.group.alert.configAlerts.nocontrol">
                <tiles2:putAttribute name="resourceId" value="${Resource.id}" />
                <tiles2:putAttribute name="resourceType" value="${entityId.type}" />
            </tiles2:insertDefinition>
        </c:otherwise>
    </c:choose>
<c:url var="removeConfigActionUrl" value="/alerts/RemoveConfig.do" />
<!-- FORM -->
<form:form action="${removeConfigActionUrl}" name="RemoveConfigForm">

<%
//org.hyperic.hq.appdef.shared.AppdefGroupValue agv = (org.hyperic.hq.appdef.shared.AppdefGroupValue)request.getAttribute("Resource");
//out.println(agv.getId());
//out.println(agv.getGroupType());
%>
<input type="hidden" name="rid" value="${Resource.id}" />
<input type="hidden" name="type" value="${Resource.entityId.type}" />

<tiles2:insertDefinition name=".portlet.confirm"/>
<display:table cellspacing="0" cellpadding="0" width="100%"
               action="${sortAction}" items="${Definitions}" >
  <display:column width="1%" property="id" 
                  title="<input type=\"checkbox\" onclick=\"ToggleAll(this, widgetProperties)\" name=\"listToggleAll\">"  
                   isLocalizedTitle="false" styleClass="ListCellCheckbox" headerStyleClass="ListHeaderCheckbox" >
  <display:checkboxdecorator name="definitions" onclick="ToggleSelection(this,widgetProperties)" styleClass="listMember"/>
  </display:column>

  <display:column width="29%" property="name" sort="true" sortAttr="1"
                  defaultSort="false" title="alerts.config.DefinitionList.ListHeader.AlertDefinition" href="/alerts/Config.do?mode=viewGroupDefinition&eid=${fn:escapeXml(Resource.entityId.appdefKey)}" paramId="ad" paramProperty="id"/>
    
  <display:column width="30%" property="description"
                  title="common.header.Description" />

  <display:column width="15%" property="ctime" sort="true" sortAttr="2"
                  defaultSort="true" title="alerts.config.DefinitionList.ListHeader.DateCreated" >
    <display:eventdatetimedecorator/>
  </display:column>
                  
   <display:column width="15%" property="mtime" sort="true" sortAttr="2"
                  defaultSort="false" title="resource.common.monitor.visibility.metricmetadata.collection.lastModified" >
    <display:eventdatetimedecorator/>
  </display:column>

   <display:column width="10%" property="enabled"
                  title="alerts.config.DefinitionList.ListHeader.Active">
    <display:booleandecorator flagKey="yesno"/>
  </display:column>

</display:table>

<tiles2:insertDefinition name=".toolbar.list">
<!-- only show new alert def link if user can see it -->
<hq:userResourcePermissions debug="false" resource="${Resource}"/>
    <c:choose>
        <c:when test="${not canModify}" >
            <tiles2:putAttribute name="noButtons" value="true"/>
        </c:when>
        <c:when test="${canAlert}" >
            <tiles2:putAttribute name="listNewUrl" value="${newAction}"/> 
            <tiles2:putAttribute name="goButtonLink" value="javascript:setActiveInactive()"/>
        </c:when>
        <c:otherwise>
            <tiles2:putAttribute name="deleteOnly" value="true"/>
            <tiles2:putAttribute name="goButtonLink" value="javascript:setActiveInactive()"/>
        </c:otherwise>
    </c:choose>
  <tiles2:putAttribute name="listItems" value="${Definitions}"/>
  <tiles2:putAttribute name="listSize" value="${Definitions.getTotalSize()}" />
  <tiles2:putAttribute name="pageNumAction" value="${pnAction}"/>
  <tiles2:putAttribute name="pageSizeAction" value="${psAction}"/>
  <tiles2:putAttribute name="defaultSortColumn" value="1"/>
  <tiles2:putAttribute name="widgetInstanceName" value="${widgetInstanceName}"/>
</tiles2:insertDefinition>

<br>
<!--html:hidden property="setActiveInactive"/-->
<input type="hidden" name="setActiveInactive" />
</form:form>

<!-- /  -->
